// 
// AYA version 5
//
// 1̃t@CNX@CFile1
// written by umeici. 2004
// 

#ifndef POSIX
#  include "stdafx.h"
#else
#  include "manifest.h"
#endif
#include "file.h"
#include "misc.h"
#include "ccct.h"
#include "wsex.h"

/* -----------------------------------------------------------------------
 *  ֐  F  CFile1::Open
 *  @\TvF  t@CI[v܂
 *
 *  Ԓl@@F@0/1=s/(Ƀ[hĂ܂)
 * -----------------------------------------------------------------------
 */
int	CFile1::Open(void)
{
	if (fp != NULL)
		return 1;

	char	*filepath = Ccct::Ucs2ToMbcs(name, CHARSET_DEFAULT);
	if (filepath == NULL)
		return 0;

	fp = w_fopen((wchar_t *)name.c_str(), (wchar_t *)mode.c_str());
	free(filepath);
	
	return (fp != NULL) ? 1 : 0;
}

/* -----------------------------------------------------------------------
 *  ֐  F  CFile1::Close
 *  @\TvF  t@CN[Y܂
 *
 *  Ԓl@@F@1/2=/[hĂȂA͊unloadĂ
 * -----------------------------------------------------------------------
 */
int	CFile1::Close(void)
{
	if (fp == NULL)
		return 2;

	fclose(fp);

	return 1;
}

/* -----------------------------------------------------------------------
 *  ֐  F  CFile1::Write
 *  @\TvF  t@Cɕ݂܂
 *
 *  Ԓl@@F@0/1=s/
 * -----------------------------------------------------------------------
 */
int	CFile1::Write(const wstring &istr)
{
	if (fp == NULL)
		return 0;

	// }`oCgR[hɕϊ
	char	*t_istr = Ccct::Ucs2ToMbcs(istr, charset);
	if (t_istr == NULL)
		return 0;

	long	len = (long)strlen(t_istr);

	// 
	fwrite(t_istr, sizeof(char), len, fp);
	free(t_istr);

	return 1;
}

/* -----------------------------------------------------------------------
 *  ֐  F  CFile1::Read
 *  @\TvF  t@C當1sǂݎ܂
 *
 *  Ԓl@@F@-1/0/1=EOF/s/
 * -----------------------------------------------------------------------
 */
int	CFile1::Read(wstring &ostr)
{
	ostr = L"";

	if (fp == NULL)
		return 0;

	if (ws_fgets(ostr, fp, charset, 0, bomcheck) == WS_EOF)
		return -1;

	bomcheck++;

	return 1;
}
