// 
// AYA version 5
//
// O[oϐNX@CGlobalVariable
// written by umeici. 2004
// 

#ifndef POSIX
#  include "stdafx.h"
#endif
#include "basis.h"
#include "variable.h"
#include "value.h"
#include "misc.h"
#include "log.h"
#include "wsex.h"
#include "ccct.h"

extern CBasis	basis;

/* -----------------------------------------------------------------------
 *  ֐  F  CGlobalVariable::Make
 *  @\TvF  ϐ쐬܂
 *  @@F  erased 0/1=L/
 *
 *  Ԓl@@F  ǉʒu
 *
 *  w肳ꂽO̕ϐɑ݂Ăꍇ͒ǉ͍s킸ÄʒuԂ܂
 * -----------------------------------------------------------------------
 */
int	CGlobalVariable::Make(const wstring &name, char erased)
{
	// ɑ݂邩ׁA݂Ă炻Ԃ
	int	i = 0;
	for(vector<CVariable>::iterator it = var.begin(); it != var.end(); it++, i++)
		if (!name.compare(it->name)) {
			if (!basis.IsRun()) {
				if (erased)
					it->Erase();
				else
					it->Enable();
			}
		return i;
		}

	// 쐬
	CVariable	addvariable(name);
	if (erased)
		addvariable.Erase();
	else
		addvariable.Enable();
	var.push_back(addvariable);

	return var.size() - 1;
}

/* -----------------------------------------------------------------------
 *  ֐  F  CGlobalVariable::GetMacthedLongestNameLength
 *  @\TvF  w肳ꂽɃ}b`閼OϐTA}b`Ԃ܂
 *
 *  ꍇ͍Œ̂̂Ԃ܂BȂꍇ0Ԃ܂
 * -----------------------------------------------------------------------
 */
int	CGlobalVariable::GetMacthedLongestNameLength(const wstring &name)
{
	int	max_len = 0;

	for(vector<CVariable>::iterator it = var.begin(); it != var.end(); it++) {
		int	len = it->name.size();
		if (!it->IsErased() && max_len < len && !it->name.compare(name.substr(0, len)))
			max_len = len;
	}

	return max_len;
}

/* -----------------------------------------------------------------------
 *  ֐  F  CGlobalVariable::GetIndex
 *  @\TvF  w肳ꂽO̕ϐ̈ʒuԂ܂
 *
 *  Ȃꍇ-1Ԃ܂
 * -----------------------------------------------------------------------
 */
int		CGlobalVariable::GetIndex(const wstring &name)
{
	int	i = 0;
	for(vector<CVariable>::iterator it = var.begin(); it != var.end(); it++, i++)
		if (!name.compare(it->name))
			return (it->IsErased()) ? -1 : i;

	return -1;
}
